Index: trunk/NEMO/OPA_SRC/ZDF/zdftke.F90
===================================================================
--- trunk/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 1531)
+++ trunk/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 1532)
@@ -1,93 +1,105 @@
-MODULE zdftke_old
+MODULE zdftke
    !!======================================================================
-   !!                       ***  MODULE  zdftke_old  ***
+   !!                       ***  MODULE  zdftke  ***
    !! Ocean physics:  vertical mixing coefficient computed from the tke 
    !!                 turbulent closure parameterization
    !!=====================================================================
-   !! History :   OPA  !  1991-03  (b. blanke)  Original code
-   !!             7.0  !  1991-11  (G. Madec)   bug fix
-   !!             7.1  !  1992-10  (G. Madec)   new mixing length and eav
-   !!             7.2  !  1993-03  (M. Guyon)   symetrical conditions
-   !!             7.3  !  1994-08  (G. Madec, M. Imbard)  nn_pdl flag
-   !!             7.5  !  1996-01  (G. Madec)   s-coordinates
-   !!             8.0  !  1997-07  (G. Madec)   lbc
-   !!             8.1  !  1999-01  (E. Stretta) new option for the mixing length
-   !!  NEMO       1.0  !  2002-06  (G. Madec) add zdf_tke_init routine
-   !!              -   !  2002-08  (G. Madec)  rn_cri and Free form, F90
-   !!              -   !  2004-10  (C. Ethe )  1D configuration
-   !!             2.0  !  2006-07  (S. Masson)  distributed restart using iom
-   !!             3.0  !  2008-05  (C. Ethe,  G.Madec) : update TKE physics:
-   !!                              - tke penetration (wind steering)
-   !!                              - suface condition for tke & mixing length
-   !!                              - Langmuir cells
-   !!              -   !  2008-05  (J.-M. Molines, G. Madec)  2D form of avtb
-   !!              -   !  2008-06  (G. Madec)  style + DOCTOR name for namelist parameters
+   !! History :  OPA  !  1991-03  (b. blanke)  Original code
+   !!            7.0  !  1991-11  (G. Madec)   bug fix
+   !!            7.1  !  1992-10  (G. Madec)   new mixing length and eav
+   !!            7.2  !  1993-03  (M. Guyon)   symetrical conditions
+   !!            7.3  !  1994-08  (G. Madec, M. Imbard)  nn_pdl flag
+   !!            7.5  !  1996-01  (G. Madec)   s-coordinates
+   !!            8.0  !  1997-07  (G. Madec)   lbc
+   !!            8.1  !  1999-01  (E. Stretta) new option for the mixing length
+   !!  NEMO      1.0  !  2002-06  (G. Madec) add tke_init routine
+   !!             -   !  2002-08  (G. Madec)  rn_cri and Free form, F90
+   !!             -   !  2004-10  (C. Ethe )  1D configuration
+   !!            2.0  !  2006-07  (S. Masson)  distributed restart using iom
+   !!            3.0  !  2008-05  (C. Ethe,  G.Madec) : update TKE physics:
+   !!                 !           - tke penetration (wind steering)
+   !!                 !           - suface condition for tke & mixing length
+   !!                 !           - Langmuir cells
+   !!             -   !  2008-05  (J.-M. Molines, G. Madec)  2D form of avtb
+   !!             -   !  2008-06  (G. Madec)  style + DOCTOR name for namelist parameters
+   !!             -   !  2008-12  (G. Reffray) stable discretization of the production term 
+   !!            3.2  !  2009-06  (G. Madec, S. Masson) TKE restart compatible with key_cpl 
+   !!                 !                                + cleaning of the parameters + bugs correction
    !!----------------------------------------------------------------------
-#if defined key_zdftke_old   ||   defined key_esopa
+#if defined key_zdftke   ||   defined key_esopa
    !!----------------------------------------------------------------------
-   !!   'key_zdftke_old'                               TKE vertical physics
+   !!   'key_zdftke'                                   TKE vertical physics
    !!----------------------------------------------------------------------
+   !!   zdf_tke       : update momentum and tracer Kz from a tke scheme
+   !!   tke_tke       : tke time stepping: update tke at now time step (en)
+   !!   tke_avn       : compute mixing length scale and deduce avm and avt
+   !!   tke_init      : initialization, namelist read, and parameters control
+   !!   tke_rst       : read/write tke restart in ocean restart file
    !!----------------------------------------------------------------------
-   !!   zdf_tke_old  : update momentum and tracer Kz from a tke scheme
-   !!   zdf_tke_init : initialization, namelist read, and parameters control
-   !!   tke_rst      : read/write tke restart in ocean restart file
-   !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and active tracers 
-   USE dom_oce         ! ocean space and time domain
-   USE zdf_oce         ! ocean vertical physics
-   USE sbc_oce         ! surface boundary condition: ocean
-   USE phycst          ! physical constants
-   USE zdfmxl          ! mixed layer
-   USE restart         ! only for lrst_oce
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE prtctl          ! Print control
-   USE in_out_manager  ! I/O manager
-   USE iom             ! I/O manager library
+   USE oce            ! ocean dynamics and active tracers 
+   USE dom_oce        ! ocean space and time domain
+   USE domvvl         ! ocean space and time domain : variable volume layer
+   USE zdf_oce        ! ocean vertical physics
+   USE sbc_oce        ! surface boundary condition: ocean
+   USE phycst         ! physical constants
+   USE zdfmxl         ! mixed layer
+   USE restart        ! only for lrst_oce
+   USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
+   USE prtctl         ! Print control
+   USE in_out_manager ! I/O manager
+   USE iom            ! I/O manager library
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   zdf_tke_old   ! routine called in step module
-
-   LOGICAL , PUBLIC, PARAMETER              ::   lk_zdftke_old = .TRUE.  !: TKE vertical mixing flag
-   REAL(wp), PUBLIC                         ::   eboost              !: multiplicative coeff of the shear product.
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   en                  !: now turbulent kinetic energy
-# if defined key_vectopt_memory
-   !                                                                !!! key_vectopt_memory
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   etmean              !: coefficient used for horizontal smoothing
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   eumean, evmean      !: at t-, u- and v-points
-# endif
+   PUBLIC   zdf_tke    ! routine called in step module
+   PUBLIC   tke_rst    ! routine called in step module
+
+   LOGICAL , PUBLIC, PARAMETER              ::   lk_zdftke = .TRUE.  !: TKE vertical mixing flag
+
 #if defined key_c1d
-   !                                                                !!! 1D cfg only
+   !                                                                !!* 1D cfg only *
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   e_dis, e_mix        !: dissipation and mixing turbulent lengh scales
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   e_pdl, e_ric        !: prandl and local Richardson numbers
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj)     ::   hlc                 !: save finite Langmuir Circulation depth
 #endif
 
+!!gm  - variables to be suppressed from the namelist:
+   LOGICAL  ::   ln_rstke = .FALSE.         ! =T restart with tke from a run without tke
+   INTEGER  ::   nn_itke  = 50              ! number of restart iterative loops
+   INTEGER  ::   nn_ave   =  1              ! horizontal average or not on avt, avmu, avmv (=0/1)
+   REAL(wp) ::   rn_cri   = 2._wp / 9._wp   ! critic Richardson number
+   REAL(wp) ::   rn_efave = 1._wp           ! coefficient for ave : ave=rn_efave*avm
+!!gm end
+
+!!gm  - variables to be added in the namelist (with a larger default value)
+   REAL(wp) ::   rn_bshear = 1.e-20   ! backgrounf shear (>0)
+!!gm
+
    !                                       !!! ** Namelist  namtke  **
-   LOGICAL  ::   ln_rstke = .FALSE.         ! =T restart with tke from a run without tke
    LOGICAL  ::   ln_mxl0  = .FALSE.         ! mixing length scale surface value as function of wind stress or not
-   LOGICAL  ::   ln_lc    = .FALSE.         ! Langmuir cells (LC) as a source term of TKE or not
-   INTEGER  ::   nn_itke  = 50              ! number of restart iterative loops
    INTEGER  ::   nn_mxl   =  2              ! type of mixing length (=0/1/2/3)
+!!gm to be change: the ref value of lmin0 and lmin
+   REAL(wp) ::   rn_lmin0 = 0.4_wp          ! surface  min value of mixing length   [m]
+   REAL(wp) ::   rn_lmin  = 0.1_wp          ! interior min value of mixing length   [m]
    INTEGER  ::   nn_pdl   =  1              ! Prandtl number or not (ratio avt/avm) (=0/1)
-   INTEGER  ::   nn_ave   =  1              ! horizontal average or not on avt, avmu, avmv (=0/1)
    INTEGER  ::   nn_avb   =  0              ! constant or profile background on avt (=0/1)
    REAL(wp) ::   rn_ediff = 0.1_wp          ! coefficient for avt: avt=rn_ediff*mxl*sqrt(e)
    REAL(wp) ::   rn_ediss = 0.7_wp          ! coefficient of the Kolmogoroff dissipation 
    REAL(wp) ::   rn_ebb   = 3.75_wp         ! coefficient of the surface input of tke
-   REAL(wp) ::   rn_efave = 1._wp           ! coefficient for ave : ave=rn_efave*avm
-   REAL(wp) ::   rn_emin  = 0.7071e-6_wp    ! minimum value of tke (m2/s2)
-   REAL(wp) ::   rn_emin0 = 1.e-4_wp        ! surface minimum value of tke (m2/s2)
-   REAL(wp) ::   rn_cri   = 2._wp / 9._wp   ! critic Richardson number
+   REAL(wp) ::   rn_emin  = 0.7071e-6_wp    ! minimum value of tke           [m2/s2]
+   REAL(wp) ::   rn_emin0 = 1.e-4_wp        ! surface minimum value of tke   [m2/s2]
    INTEGER  ::   nn_havtb = 1               ! horizontal shape or not for avtb (=0/1)
    INTEGER  ::   nn_etau  = 0               ! type of depth penetration of surface tke (=0/1/2)
    INTEGER  ::   nn_htau  = 0               ! type of tke profile of penetration (=0/1/2)
-   REAL(wp) ::   rn_lmin0 = 0.4_wp          ! surface  min value of mixing length
-   REAL(wp) ::   rn_lmin  = 0.1_wp          ! interior min value of mixing length
    REAL(wp) ::   rn_efr   = 1.0_wp          ! fraction of TKE surface value which penetrates in the ocean
+   LOGICAL  ::   ln_lc    = .FALSE.         ! Langmuir cells (LC) as a source term of TKE or not
    REAL(wp) ::   rn_lc    = 0.15_wp         ! coef to compute vertical velocity of Langmuir cells
 
-   REAL(wp), DIMENSION (jpi,jpj) ::   avtb_2d   ! set in tke_init, for other modif than ice
+   REAL(wp) ::   ri_cri   ! critic Richardson number (deduced from rn_ediff and rn_ediss values)
+
+   REAL(wp), DIMENSION(jpi,jpj)     ::   htau      ! depth of tke penetration (nn_htau)
+   REAL(wp), DIMENSION(jpi,jpj)     ::   avtb_2d   ! set in tke_init, for other modif than ice
+   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   en        ! now turbulent kinetic energy   [m2/s2]
+   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   dissl     ! now mixing lenght of dissipation
 
    !! * Substitutions
@@ -95,6 +107,6 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.0 , LOCEAN-IPSL (2008) 
-   !! $Id$
+   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! $Id: zdftke2.F90 1201 2008-09-24 13:24:21Z rblod $
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -102,58 +114,39 @@
 CONTAINS
 
-   SUBROUTINE zdf_tke_old( kt )
+   SUBROUTINE zdf_tke( kt )
       !!----------------------------------------------------------------------
-      !!                   ***  ROUTINE zdf_tke_old  ***
+      !!                   ***  ROUTINE zdf_tke  ***
       !!
       !! ** Purpose :   Compute the vertical eddy viscosity and diffusivity
-      !!      coefficients using a 1.5 turbulent closure scheme.
-      !!
-      !! ** Method  :   The time evolution of the turbulent kinetic energy 
-      !!      (tke) is computed from a prognostic equation :
-      !!         d(en)/dt = eboost eav (d(u)/dz)**2         ! shear production
-      !!                  + d( rn_efave eav d(en)/dz )/dz   ! diffusion of tke
-      !!                  + grav/rau0 pdl eav d(rau)/dz     ! stratif. destruc.
-      !!                  - rn_ediss / emxl en**(2/3)       ! dissipation
+      !!              coefficients using a turbulent closure scheme (TKE).
+      !!
+      !! ** Method  :   The time evolution of the turbulent kinetic energy (tke)
+      !!              is computed from a prognostic equation :
+      !!         d(en)/dt = avm (d(u)/dz)**2             ! shear production
+      !!                  + d( avm d(en)/dz )/dz         ! diffusion of tke
+      !!                  + avt N^2                      ! stratif. destruc.
+      !!                  - rn_ediss / emxl en**(2/3)    ! Kolmogoroff dissipation
       !!      with the boundary conditions:
       !!         surface: en = max( rn_emin0, rn_ebb sqrt(utau^2 + vtau^2) )
       !!         bottom : en = rn_emin
-      !!      -1- The dissipation and mixing turbulent lengh scales are computed
-      !!         from the usual diagnostic buoyancy length scale:  
-      !!         mxl= sqrt(2*en)/N  where N is the brunt-vaisala frequency
-      !!         with mxl = rn_lmin at the bottom minimum value of 0.4
-      !!      Four cases : 
-      !!         nn_mxl=0 : mxl bounded by the distance to surface and bottom.
-      !!                  zmxld = zmxlm = mxl
-      !!         nn_mxl=1 : mxl bounded by the vertical scale factor.
-      !!                  zmxld = zmxlm = mxl
-      !!         nn_mxl=2 : mxl bounded such that the vertical derivative of mxl 
-      !!                  is less than 1 (|d/dz(xml)|<1). 
-      !!                  zmxld = zmxlm = mxl
-      !!         nn_mxl=3 : lup = mxl bounded using |d/dz(xml)|<1 from the surface 
-      !!                        to the bottom
-      !!                  ldown = mxl bounded using |d/dz(xml)|<1 from the bottom 
-      !!                        to the surface
-      !!                  zmxld = sqrt (lup*ldown) ; zmxlm = min(lup,ldown)
-      !!      -2- Compute the now Turbulent kinetic energy. The time differencing
-      !!      is implicit for vertical diffusion term, linearized for kolmo-
-      !!      goroff dissipation term, and explicit forward for both buoyancy
-      !!      and dynamic production terms. Thus a tridiagonal linear system is
-      !!      solved.
-      !!         Note that - the shear production is multiplied by eboost in order
-      !!      to set the critic richardson number to rn_cri (namelist parameter)
-      !!                   - the destruction by stratification term is multiplied
-      !!      by the Prandtl number (defined by an empirical funtion of the local 
-      !!      Richardson number) if nn_pdl=1 (namelist parameter)
-      !!      coefficient (zesh2):
-      !!      -3- Compute the now vertical eddy vicosity and diffusivity
-      !!      coefficients from en (before the time stepping) and zmxlm:
-      !!              avm = max( avtb, rn_ediff*zmxlm*en^1/2 )
-      !!              avt = max( avmb, pdl*avm )  (pdl=1 if nn_pdl=0)
+      !!      The associated critical Richardson number is: ri_cri = 2/(2+rn_ediss/rn_ediff) 
+      !!
+      !!        The now Turbulent kinetic energy is computed using the following 
+      !!      time stepping: implicit for vertical diffusion term, linearized semi
+      !!      implicit for kolmogoroff dissipation term, and explicit forward for 
+      !!      both buoyancy and shear production terms. Therefore a tridiagonal 
+      !!      linear system is solved. Note that buoyancy and shear terms are
+      !!      discretized in a energy conserving form (Bruchard 2002).
+      !!
+      !!        The dissipative and mixing length scale are computed from en and
+      !!      the stratification (see tke_avn)
+      !!
+      !!        The now vertical eddy vicosity and diffusivity coefficients are
+      !!      given by: 
+      !!              avm = max( avtb, rn_ediff * zmxlm * en^1/2 )
+      !!              avt = max( avmb, pdl * avm                 )  
       !!              eav = max( avmb, avm )
-      !!      avt and avm are horizontally averaged to avoid numerical insta-
-      !!      bilities.
-      !!        N.B. The computation is done from jk=2 to jpkm1 except for
-      !!      en. Surface value of avt avmu avmv are set once a time to
-      !!      their background value in routine zdf_tke_init.
+      !!      where pdl, the inverse of the Prandtl number is 1 if nn_pdl=0 and
+      !!      given by an empirical funtion of the localRichardson number if nn_pdl=1 
       !!
       !! ** Action  :   compute en (now turbulent kinetic energy)
